package tests;

import ComplexNumbers.ComplexNumbers.ComplexNumber;
import ComplexNumbers.ComplexNumbers.PolarComplexNumber;
import references.references.NumberReference;

import static ComplexNumbers.ComplexNumbers.ComplexNumbers.*;
import static mathmath.math.math.mathEpsilonCompare;
import static references.references.references.CreateNumberReference;
import static testing.testing.testing.AssertStringEquals;
import static testing.testing.testing.AssertTrue;

public class tests {
    public static double testToPolar(){
        NumberReference failuresReference;
        ComplexNumber z;
        PolarComplexNumber p;

        failuresReference = CreateNumberReference(0d);

        z = CreateComplexNumber(5d, 2d);

        p = CreatePolarFromComplexNumber(z);

        AssertTrue(mathEpsilonCompare(5.39, p.r, 0.01), failuresReference);
        AssertTrue(mathEpsilonCompare(0.38, p.phi, 0.01), failuresReference);

        z = CreateComplexFromPolar(p);

        AssertTrue(mathEpsilonCompare(5.0, z.re, 0.1), failuresReference);
        AssertTrue(mathEpsilonCompare(2.0, z.im, 0.1), failuresReference);

        return failuresReference.numberValue;
    }

    public static double test(){
        double failures;
        ComplexNumber a, b;
        PolarComplexNumber p, q;

        failures = 0d;

        failures = failures + testToPolar();

        a = CreateComplexNumber(5d, 3d);
        b = CreateComplexNumber(-3d, 2d);

        Add(a, b);
        Sub(a, b);
        Mul(a, b);
        Div(a, b);
        Conjugate(a);
        Re(a);
        Im(a);
        a = CreateComplexNumber(8d, -6d);
        SquareRoot(a);
        Power(a, 2d);
        a = CreateComplexNumber(8d, -6d);
        Negate(a);

        p = CreatePolarComplexNumber(5d, 3d);
        q = CreatePolarComplexNumber(-3d, 2d);

        AddPolar(p, q);
        SubPolar(p, q);
        MulPolar(p, q);
        DivPolar(p, q);

        failures = failures + testStringFunctions();

        return failures;
    }

    public static double testStringFunctions() {
        boolean success;
        char [] str;
        ComplexNumber a;
        NumberReference failures;

        failures = CreateNumberReference(0d);
        a = new ComplexNumber();

        //success = CreateComplexNumberFromString("1 + 2i", a);
        //AssertTrue(success, failures);
        a = CreateComplexNumber(1d, 2d);
        str = ComplexToString(a);
        AssertStringEquals("1+2i".toCharArray(), str, failures);

        a = CreateComplexNumber(3d, -5.2d);
        str = ComplexToString(a);
        AssertStringEquals("3-5.2i".toCharArray(), str, failures);

        return failures.numberValue;
    }
}
